package MDL;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class Module {
	private String name;
	private String comment;	
	private Collection<Method> methods;
	
	/**
	 * @param name : name of module
	 * @param comment : comment about the module
	 */
	public Module(String name, String comment){
		this.name = name;  //TODO: 1st letter must be caps
		this.comment = comment;		
		this.methods = new ArrayList<Method>();				
	}
	
	/**
	 * Adds methods to the module
	 * @param m : method to add
	 */
	public void addMethod(Method m){
		methods.add(m);
	}
	
	/**
	 * getter 
	 * @return name
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * getter 
	 * @return comment
	 */
	public String getComment() {
		return comment;
	}

	/**
	 * getter 
	 * @return iterator for methods
	 */
	public Iterator<Method> getMethods() {
		return methods.iterator();
	}	
}
