package MDL;

public class Param  {
	public enum Type{
		Integer,
		UnsignedInt,
		Boolean,
		Chars,
		Bytes
	}

	private String name;
	private String comment;
	private int length;
	private Type type;
	private String value;
	
	public Param(String name, String type, int length, String comment,String value){		
		this.type= getType(type);
		this.name = name;
		if (comment == null) comment = "";
		this.comment = comment;
		this.length = length;
		this.value = value;
	}
	
	private Type getType(String type){
		Type t;
		if(type.equalsIgnoreCase("int")){
			t = Type.Integer;
		}else if(type.equalsIgnoreCase("uInt")){
			t= Type.UnsignedInt;
		}else if(type.equalsIgnoreCase("chars")){
			t= Type.Chars;
		}else if(type.equalsIgnoreCase("bool")){
			t= Type.Boolean;
		}else if(type.equalsIgnoreCase("bytes")){
			t = Type.Bytes;
		}else{
			t = null;
		}
		return t;
	}
	
	public String getName() {
		return name;
	}

	public String getComment() {
		return comment;
	}

	public int getLength() {
		return length;
	}

	public Type getType() {
		return type;
	}
	
	public boolean isConstant(){
		return this.value != null;
	}
	
	public String getValue(){
		return value;
	}
	

	
	

}
