package javaCodeGen;


public abstract class JavaElement {
	private final String nl = "\n"; //new line char
	
	//Stores the accumulated result of the generated code
	static String result = "";
	
	//how many tabs in to print the next line
	private  int depth = 0;	
	//what the last value of depth was
	private  int lastDepth = 0;	 
	
	private int getDepth(){
		return depth;
	}
	
	/**
	 * @param depth how many tabs to print
	 * @return returns depth number of tabs
	 */
	private String printDepth(int depth){
		String result = "";
		for(int i = 0; i < depth; i++){
			result += "     ";
		}
		return result;		
	}
	
	/**
	 * Set Indentation
	 * @param new_depth
	 */
	void setI(int new_depth){
		lastDepth  = depth;
		depth = new_depth;
	}
	/**
	 * Set the indentation to its last value
	 */
	void setI(){
		depth = lastDepth;
	}
	
	/**
	 * Adds  a new line
	 * @param next
	 */
	protected void addL(){
		addL("", 0);
	}

	
	/**
	 * Adds the next String as a new line
	 * @param next
	 */
	protected void addL(String next){
		addL(next, 0);
	}
	
	/**
	 * Adds the next String as a new line
	 * @param next
	 * @param shifts : shifts indentation
	 */
	protected void addL(String next, int shifts){
		result = (result + printDepth(getDepth() + shifts) +next +nl);
	}
	
	/**
	 * @return the accumulated result string so far
	 */
	String getResult(){
		return result;
	}

}
